package com.goafanti.common.dao;

import com.goafanti.common.model.UserDataLog;
import com.goafanti.customer.bo.OutUserDateLogList;
import org.apache.ibatis.annotations.Param;

import java.awt.print.Pageable;
import java.util.List;

/**
 * 用户信息日志(UserDataLog)表数据库访问层
 *
 * @author makejava
 * @since 2024-09-29 09:52:13
 */
public interface UserDataLogMapper {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    UserDataLog queryById(Integer id);


    /**
     * 查询指定行数据
     *
     * @param userDataLog 查询条件
     * @param pageable    分页对象
     * @return 对象列表
     */
    List<UserDataLog> findUserDataLogList(UserDataLog userDataLog, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param userDataLog 查询条件
     * @return 总行数
     */
    int findUserDataLogCount(UserDataLog userDataLog);

    /**
     * 新增数据
     *
     * @param userDataLog 实例对象
     * @return 影响行数
     */
    int insert(UserDataLog userDataLog);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<UserDataLog> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<UserDataLog> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<UserDataLog> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<UserDataLog> entities);

    /**
     * 修改数据
     *
     * @param userDataLog 实例对象
     * @return 影响行数
     */
    int update(UserDataLog userDataLog);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);


    List<OutUserDateLogList> userDateLogList(String uid);
}